#ifndef _OSD_BB_H_
#define _OSD_BB_H_

#include "osd_wrap.h"

#define STR_SZ		256

#define BB_MSG		0
#define BB_DEBUG	BB_MSG+ 1
#define BB_INFO		BB_MSG+ 2
#define BB_WARN		BB_MSG+ 3
#define BB_ERROR	BB_MSG+ 4

#define BBERR		0
#define BBERR_NOMEM	BBERR+ 1

#define BB_ALIVE	0
#define	BB_DIE		1

#define DO_COPY		1
#define NO_COPY		0

#define DO_NOTHING	do{}while(0)

#define BB_ASSERT(x)	do{	if(!(x))	BUG();	}while(0)

#define WRITE_CMD(x) (((x)->cmnd[0]==0x2a) || ((x)->cmnd[0]==0x8a) || ((x)->cmnd[0]== 0x0a))
#define READ_CMD(x)  (((x)->cmnd[0]==0x28) || ((x)->cmnd[0]==0x88) || ((x)->cmnd[0]== 0x08))

#define BB_PAGE_SIZE	128*1024 //for remove osd_main.c:max_sectors=256
//#define BB_PAGE_SIZE    512*1024
#define BB_MAX_SG	1
#define BB_CAN_QUEUE    16
//#define BB_CAN_QUEUE    4
#define BB_PAGES	(BB_CAN_QUEUE * BB_MAX_SG)
#define BB_SIZE   	(BB_PAGES * BB_PAGE_SIZE)

#define NOBBPAGE	9

typedef struct _BBUF{
        dma_addr_t      PhyAddr;
        unsigned char   *VirtAddr;
	struct page	*Page;
        struct _BBUF    *next;
} BBUF_T, *pBBUF_T;

typedef struct _SGTRANS{
        Scsi_Cmnd       	*cmd;
	int			old_sgcnt;
        unsigned char 		*old_req_buf;		// old request_buf in scatterlist
	unsigned char 		*new_req_buf;		// ptr point to request_buffer
        pBBUF_T         	bbuf;
        struct scatterlist      request_buffer[BB_MAX_SG];
        struct _SGTRANS 	*next;
} SGTRANS_T, *pSGTRANS_T;


typedef struct _sg_optable{
        struct scatterlist	*src_sg;     		// head of sglist
        int			src_sgcnt;              // count of sg number
	int			current_src_idx;        // current position of sg
	unsigned char		*current_src_vaddr;	// virtual address of sg
	int			src_buff_remain;	// how many buffer avaliable of current sg 
	int			src_is_highmem;		// denotes a highmem sg
	struct page		*src_high_page;		// current high page
	int			src_high_remain;	// current high page remain
	unsigned char           *src_mapped_vaddr;	// kmaped virtual address

        struct scatterlist 	*dst_sg;
        int			dst_sgcnt;
	int			current_dst_idx;
	unsigned char		*current_dst_vaddr;
	int			dst_buff_remain;
	int			dst_is_highmem;
	struct page		*dst_high_page;
	int			dst_high_remain;
	unsigned char           *dst_mapped_vaddr;

        int	r_o_w;          	// denotes read/write command
        int	handled_buff_sz;	// denotes alcho processed size
} sg_optable_t;


/* bounce-buffer declarations */
typedef struct {
        BBUF_T          BBuf[BB_PAGES];
        SGTRANS_T       SgTransTbl[CAN_QUEUE];
        pSGTRANS_T      pSgTransCurrent;
	int		cmd_reject_threshold;
	int		present;
        spinlock_t      sg_trans_lock, bb_lock;
} bb_t;

#define BB_LOCK(lock, flags)		spin_lock_irqsave(lock, flags)
#define BB_UNLOCK(lock, flags)		spin_unlock_irqrestore(lock, flags)
extern int bb_ret;


#endif
