#ifndef OSD_CONS_h
#define OSD_CONS_h

#if defined(ATI)
	#define VERSION_MAJOR			  	3	
	#define VERSION_MINOR				1		
	#define VERSION_OEMCODE				1540
	#define VERSION_BUILDNUM			46	
	#define FASTTRAK_DRIVER_VERSION "3.1.1540.46"

#elif defined(AHCI_INTEL)
	#define VERSION_MAJOR                           1
	#define VERSION_MINOR                           2
	#define VERSION_OEMCODE                         140
	#define VERSION_BUILDNUM                        32
	#define FASTTRAK_DRIVER_VERSION "1.2.140.32"

#elif defined(T8_SUPPORT)
	#define VERSION_MAJOR                           1
	#define VERSION_MINOR                           2
	#define VERSION_OEMCODE                         0
	#define VERSION_BUILDNUM                        58
	#define FASTTRAK_DRIVER_VERSION "1.2.0.58"

#else
	#define VERSION_MAJOR				1
	#define VERSION_MINOR				1
	#define VERSION_OEMCODE				0
	#define VERSION_BUILDNUM			58

	#define FASTTRAK_DRIVER_VERSION "1.1.0.58"
#endif


#define FASTTRAK_DRIVER_DATE				"(May 11, 2009)"

#define FASTTRAK_DRIVER_NAME 				"t3sas"

/* controller related definitions */
#if !defined(MAX_ADAPTORS)
	#define MAX_ADAPTORS	 5
#endif

#define PCI_REVISION_ID_ADDRESS				8
#define PCI_VENDOR_ID_FASTTRAK_PROMISE 			0x105a
#define PCI_DEVICE_ID_SX4000				0x6621
#define PCI_DEVICE_ID_SX4				0x6622
#define PCI_DEVICE_ID_SX4100				0x6624
#define PCI_DEVICE_ID_NAPA				0x6300

#define VEN_DEV_SX4000					0x105A6621
#define SUB_VEN_DEV_SX4000				VEN_DEV_SX4000
#define VEN_DEV_SX4					0x105A6622
#define SUB_VEN_DEV_SX4					VEN_DEV_SX4
#define VEN_DEV_SX4100					0x105A6624
#define SUB_VEN_DEV_SX4100				VEN_DEV_SX4100
#define VEN_DEV_NAPA					0x105A6300
#define SUB_VEN_DEV_NAPA				VEN_DEV_NAPA


#if defined(OCTOPUSII)
        #define MAX_ADAPTER_TYPE                        		7
	#define VENID_LIST  	{					\
			          PCI_VENDOR_ID_FASTTRAK_PROMISE	\
        			, PCI_VENDOR_ID_FASTTRAK_PROMISE	\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE	\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE	\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE	\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE	\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE	\
				}

        #define DEVID_LIST      {                       					\
			          0x3571                /* TX2200 */				\
			        , 0x3570                /* TX2300 */				\
			        , 0x3574                /* FT579  */				\
			        , 0x3577                /* FT779 */				\
			//      , 0x3519                /* TX4200 */				\
			        , 0x3515                /* TX4300 */				\
			        , 0x3d17                /* SATA300 TX4/Tx4302 */		\
			        , 0x3d73                /* SATA300 TX2plus /eSATA300 Tx2*/	\
                                }

        #define VENDEVID_LIST   {                       					\
			          0x105a3571            /* TX2200 */				\
			        , 0x105a3570            /* TX2300 */				\
			        , 0x105a3574            /* FT579  */				\
			        , 0x105a3577            /* FT779 */				\
			//      , 0x105a3519            /* TX4200 */				\
			        , 0x105a3515            /* TX4300 */				\
			        , 0x105a3d17            /* SATA300 TX4/Tx4302 */		\
			        , 0x105a3d73            /* SATA300 TX2plus /eSATA300 Tx2*/	\
                                }

        #define SUBVENDEVID_LIST{                       					\
			          0x105a3571            /* TX2200 */				\
			        , 0x105a3570            /* TX2300 */				\
			        , 0x105a3574            /* FT579  */				\
			        , 0x105a3577            /* FT779 */				\
			//      , 0x105a3519            /* TX4200 */				\
			        , 0x105a3515            /* TX4300 */				\
			        , 0x105a3d17            /* SATA300 TX4/Tx4302 */		\
			        , 0x105a3d73            /* SATA300 TX2plus /eSATA300 Tx2*/	\
                                }

	#define PCI_DEVICE_ID_LIST{											\
	        		{ 0x105a, 0x3571, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, //TX2200				\
			        /*{ 0x105a, 0x3519, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },*/				\
			        { 0x105a, 0x3574, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, //FT579				\
			        { 0x105a, 0x3570, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, //TX2300				\
			        { 0x105a, 0x3577, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, //FT779				\
			        { 0x105a, 0x3515, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, //TX4300				\
			        { 0x105a, 0x3d17, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, //SATA300 TX4/Tx4302		\
		        	{ 0x105a, 0x3d73, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, //SATA300 TX2plus /eSATA300 Tx2	\
				{ 0, 0, 0, 0, 0, 0, 0UL},								\
				}


#elif defined(NAPA_MARVELL)
        #define MAX_ADAPTER_TYPE                        1
        #define VENID_LIST      {                       \
				  0x11ab		\
                                }

        #define DEVID_LIST      {			\
			          0x6081		\
				}

        #define VENDEVID_LIST   {			\
			          0x11ab6081		\
				}

        #define SUBVENDEVID_LIST{			\
			          0x11ab6081		\
				}
	#define PCI_DEVICE_ID_LIST{							\
				{ 0x11ab, 0x6081, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
				{ 0, 0, 0, 0, 0, 0, 0UL},				\
				}
#elif defined(NAPA_FPGA)
        #define MAX_ADAPTER_TYPE                        			7
        #define VENID_LIST      {                       			\
			        /* SX4300/8300*/				\
			          PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
                                }

        #define DEVID_LIST      {                       \
			        /* SX4300/8300*/	\
			          0x6300		\
			        , 0x6301		\
			        , 0x6302		\
			        , 0x6303		\
			        , 0x6304		\
			        , 0x6305		\
			        , 0x6306		\
			        , 0x6307		\
                                }

        #define VENDEVID_LIST   {                       \
			        /* SX4300/8300*/	\
			          0x105a6300		\
			        , 0x105a6301		\
			        , 0x105a6302		\
			        , 0x105a6303		\
			        , 0x105a6304		\
			        , 0x105a6305		\
			        , 0x105a6306		\
			        , 0x105a6307		\
                                }

        #define SUBVENDEVID_LIST{                       \
			        /* SX4300/8300*/	\
			          0x105a6300		\
			        , 0x105a6301		\
			        , 0x105a6302		\
			        , 0x105a6303		\
			        , 0x105a6304		\
			        , 0x105a6305		\
			        , 0x105a6306		\
			        , 0x105a6307		\
                                }
	#define PCI_DEVICE_ID_LIST{                                                     \
			        /* SX4300/8300*/					\
			        { 0x105a, 0x6300, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x105a, 0x6301, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x105a, 0x6302, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x105a, 0x6303, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
        			{ 0x105a, 0x6304, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
				{ 0x105a, 0x6305, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x105a, 0x6306, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x105a, 0x6307, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
                                { 0, 0, 0, 0, 0, 0, 0UL},                               \
                                }

#elif defined(AHCI_INTEL)
        #define MAX_ADAPTER_TYPE                      	10
        #define VENID_LIST      {                       \
			          0x8086		\
			        , 0x8086		\
			        , 0x8086		\
			        , 0x8086		\
			        , 0x8086		\
			        , 0x1002		\
			        , 0x1002		\
			        , 0x8086		\
			        , 0x8086		\
			        , 0x8086		\
                                }

        #define DEVID_LIST      {                       \
			          0x2652		\
			        , 0x2653		\
			        , 0x27c1		\
			        , 0x27c5		\
			        , 0x27c3		\
			        , 0x4380		\
			        , 0x4381		\
			        , 0x2652		\
			        , 0x2822		\
			        , 0x2922		\
                                }

        #define VENDEVID_LIST   {                       \
			          0x80862652		\
			        , 0x80862653		\
			        , 0x808627c1		\
			        , 0x808627c5		\
			        , 0x808627c3		\
			        , 0x10024380		\
			        , 0x10024381		\
			        , 0x80862652		\
			        , 0x80862822		\
			        , 0x80862922		\
                                }

        #define SUBVENDEVID_LIST{                       \
			          0x80862652		\
			        , 0x80862653		\
			        , 0x808627c1		\
			        , 0x808627c5		\
			        , 0x808627c3		\
			        , 0x10024380		\
			        , 0x10024381		\
			        , 0x80862652  	\
			        , 0x80862822		\
			        , 0x80862922		\
                                }

        #define PCI_DEVICE_ID_LIST{                                                     	\
			        { 0x8086, 0x2652, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, // ICH6	\
			        { 0x8086, 0x2653, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, // ICH6M	\
			        { 0x8086, 0x27c1, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, // ICH7	\
				    { 0x8086, 0x27c5, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, // ICH7M	\
			        { 0x8086, 0x27c3, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, // ICH7R	\
			        { 0x1002, 0x4380, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },		\
			        { 0x1002, 0x4381, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },		\
			        { 0x8086, 0x2652, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },		\
			        { 0x8086, 0x2822, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },		\
			        { 0x8086, 0x2922, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },		\
                                { 0, 0, 0, 0, 0, 0, 0UL},                               	\
                                }


#elif defined(SUPPORT_T3)
        #define MAX_ADAPTER_TYPE        		        	        9
	#define VENID_LIST  	{						\
		          	  PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
				}

	#define DEVID_LIST	{			\
				  0x3f20		\
        			, 0x3f20		\
        			, 0x3f20		\
        			, 0x3f19		\
			        , 0x3f19		\
			        , 0x3f19		\
			        , 0x3f20		\
			        , 0x3f20		\
			        , 0x377d		\
				}

	#define VENDEVID_LIST	{						\
			          0x105A3f20 /*FastTrak PDC42819*/		\
			        , 0x105A3f20 /*FastTrak TX2650*/		\
			        , 0x105A3f20 /*FastTrak TX4650*/		\
			        , 0x105A3f19 /*SATA TX2650*/			\
			        , 0x105A3f19 /*SATA TX4650*/			\
			        , 0x105A3f19 /*SATA TX4652*/			\
			        , 0x105A3f20 /*FastTrak TX4652 for ACER*/	\
			        , 0x105A3f20 /*FastTrak TX4650R1*/		\
			        , 0x105A377d /*T2-SAS879*/			\
				}

	#define SUBVENDEVID_LIST{						\
			          0x105A3716 /*FastTrak PDC42819*/		\
			        , 0x105A3f21 /*FastTrak TX2650*/		\
			        , 0x105A3f22 /*FastTrak TX4650*/		\
			        , 0x105A3f29 /*SATA TX2650*/			\
        			, 0x105A3f2a /*SATA TX4650*/			\
			        , 0x105A3f2b /*SATA TX4652*/			\
			        , 0x105A3f24 /*FastTrak TX4652 for ACER*/	\
			        , 0x105A3f23 /*FastTrak TX4650R1*/		\
			        , 0x105A3772 /*T2-SAS879*/			\
				}

	#define PCI_DEVICE_ID_LIST{					\
        { 0x105a, 0x3f20, 0x105a, 0x3716, 0, 0, 0 }, //FastTrak PDC42819; SubDeviceID 3F20 -> 3716(20070625)	\
        { 0x105a, 0x3f20, 0x105a, 0x3f21, 0, 0, 0 }, //FastTrak TX2650						\
        { 0x105a, 0x3f20, 0x105a, 0x3f22, 0, 0, 0 }, //FastTrak TX4650						\
        { 0x105a, 0x3f19, 0x105a, 0x3f29, 0, 0, 0 }, //SATA TX2650						\
        { 0x105a, 0x3f19, 0x105a, 0x3f2a, 0, 0, 0 }, //SATA TX4650						\
        { 0x105a, 0x3f19, 0x105a, 0x3f2b, 0, 0, 0 }, //SATA TX4652						\
        { 0x105a, 0x3f20, 0x105a, 0x3f24, 0, 0, 0 }, //FastTrak TX4652 for ACER					\
        { 0x105a, 0x3f20, 0x105a, 0x3f23, 0, 0, 0 }, //FastTrak TX4650R1 for ASUS				\
        { 0x105a, 0x377d, 0x105a, 0x3772, 0, 0, 0 }, //T2-SAS879						\
	{0, 0, 0, 0, 0, 0, 0UL},										\
	}


#elif defined(ATI)
        #define MAX_ADAPTER_TYPE                        8
        #define VENID_LIST      {                       			\
			          0x1002					\
			        , 0x1002					\
			        , 0x1002					\
			        , 0x1002					\
			        , 0x1002					\
			        , 0x1002					\
			        , 0x8086   /* ICH-8R */				\
			        , 0x1002   /*Moray RS485 (NB) */		\
                                }

        #define DEVID_LIST      {                       			\
			          0x4380					\
			        , 0x4381					\
			        , 0x4382					\
			        , 0x4391					\
			        , 0x4392					\
			        , 0x4393					\
			        , 0x2822   /* ICH-8R */				\
			        , 0x5059  /*Moray RS485 (NB) */			\
                                }

        #define VENDEVID_LIST   {                       			\
			          0x10024380					\
			        , 0x10024381					\
			        , 0x10024382					\
			        , 0x10024391					\
			        , 0x10024392					\
				, 0x10024393					\
			        , 0x80862822   /* ICH-8R */			\
			        , 0x10025059  /*Moray RS485 (NB) */		\
                                }

        #define SUBVENDEVID_LIST{                       			\
			          0x10024380					\
			        , 0x10024381					\
			        , 0x10024382					\
			        , 0x10024391					\
			        , 0x10024392					\
			        , 0x10024393					\
				, 0x80862822   /* ICH-8R */			\
			        , 0x10025059  /*Moray RS485 (NB) */		\
                                }

	#define PCI_DEVICE_ID_LIST{							\
        			{ 0x1002, 0x4380, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x1002, 0x4381, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
        			{ 0x1002, 0x4382, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
        			{ 0x1002, 0x4391, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x1002, 0x4392, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x1002, 0x4393, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x8086, 0x2822, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x1002, 0x5059, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
				{0, 0, 0, 0, 0, 0, 0UL},				\
				}
#else
        /* SX4/4000/4100*/
        #define MAX_ADAPTER_TYPE                        			4
        #define VENID_LIST      {                       			\
			        /* SX4/4000/4100*/				\
			          PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
			        , PCI_VENDOR_ID_FASTTRAK_PROMISE		\
                                }

        #define DEVID_LIST      {                       \
			        /* SX4/4000/4100*/	\
			          0x6621		\
			        , 0x6622		\
			        , 0x6623		\
			        , 0x6624		\
                                }

        #define VENDEVID_LIST   {                       \
			        /* SX4/4000/4100*/	\
			          0x105a6621		\
			        , 0x105a6622		\
			        , 0x105a6623		\
			        , 0x105a6624		\
                                }

        #define SUBVENDEVID_LIST{                       \
			        /* SX4/4000/4100*/	\
			          0x105a6621		\
			        , 0x105a6622		\
			        , 0x105a6623		\
			        , 0x105a6624		\
                                }

        #define PCI_DEVICE_ID_LIST{							\
			        /* SX4/4000/4100*/					\
			        { 0x105a, 0x6621, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x105a, 0x6622, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x105a, 0x6623, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        { 0x105a, 0x6624, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },	\
			        {0, 0, 0, 0, 0, 0, 0UL},                                \
			        }
#endif



#define OSDM_MAX_TARGET_NUM				(MAX_ARRAY_SUPPORTED+1)
#define OSDM_MAX_LUN_PER_TARGET				1

#if defined(T8_SUPPORT)
#define CAN_QUEUE					128 
#else
#define CAN_QUEUE                                       32
#endif
#define FASTTRAK_MAX_SG 				24	/* for ASIC workaround, MAX_SG < 32, 20070531  */
#define MAX_SG 						FASTTRAK_MAX_SG
#define MAX_TIMER_QUEUE 				32


/* IOCTL related definitions */
#define FASTTRAK_IOCTL_SIGNATURE1   			0x54534146
#define FASTTRAK_IOCTL_SIGNATURE2   			0x4b415254

#define MAX_DATA_BUFFER_COUNT 				2

#define CONSOLEDEVICE_TARGETID 				OSDM_MAX_TARGET_NUM - 1
#define SRB_NO_ERROR 					1
#define SRB_SELECTION_TIMEOUT   			0x0A
#define SRB_SEE_SENSE 					0x84

	/*SCSI Passthrough API Related	*/
#define ocmdEnclosure					0x0
#define ocmdBattery					0x1
#define ocmdGetAdapter					0x5

	/* For ocmdEnclosure: Enclosure Control */
#define API_ENCLOSURE_SUB_GETENCLOSURE			0x01
#define API_ENCLOSURE_SUB_GETSENSOR			0x02
#define API_ENCLOSURE_SUB_LEDLOCATE			0x03
#define API_ENCLOSURE_SUB_MAPDISKID			0x04


/* Whenever there is a component started, it'll call the OSD_ComponentStarted function. */
#define COMP_START_STATUS_SUCCESS	1

#endif /* OSD_CONS_H */

