#include "osd_hotplug.h"

#ifdef LINUX_SCSI_HOTPLUG_AWARE
        struct scsi_device *ft_sdev = NULL;
        struct Scsi_Host *ft_scsi_host = NULL;

        #define FT_MAX_EVENT_SUPPORT    8
        static struct scsi_dev_hotplug{
                struct {
                        unsigned char present;
                        unsigned char scsi_id;
                        unsigned char type;

                        unsigned char reserved; // For 4-bytes alignment.
                } event[FT_MAX_EVENT_SUPPORT];
                int event_cnt;
        } scsi_hotplug;

        struct Timer_Queue *ft_scsi_timer;
        struct work_struct scsi_aware_work;

        struct tasklet_struct scsi_aware_tasklet;
        DEFINE_SPINLOCK(wkq_lock);

        void OSD_SCSI_HotPlug_Aware(unsigned int target_id, int type){
                int i;

                for(i=0;i<FT_MAX_EVENT_SUPPORT;i++){
                        if( !scsi_hotplug.event[i].present )
                                break;
                        else    continue;
                }

                scsi_hotplug.event[i].scsi_id =  target_id;
                scsi_hotplug.event[i].type = type;
                scsi_hotplug.event[i].present = 1;
                scsi_hotplug.event_cnt++;
        }

        void do_ft_scsi_hotplug_aware(unsigned int target_id){
                unsigned int lun=0, channel=0;
                int i;
                int plug_unplug;
		unsigned long flags;
	
		spin_lock_irqsave(&wkq_lock, flags);

                while( scsi_hotplug.event_cnt > 0 ){
			/* Due to RHEL4 not have SHOST_RUNNING, I disable this check.  Dirk20090220*/
                       // if( !(ft_scsi_host->shost_state == SHOST_RUNNING))
                       //         printk("SHOST_NOT_RUNNING: %d\n", ft_scsi_host->shost_state);

                        for(i=0;i<FT_MAX_EVENT_SUPPORT;i++){
                                if( scsi_hotplug.event[i].present )
                                        break;
                                else    continue;
                        }
                        plug_unplug = scsi_hotplug.event[i].type;

                        if( plug_unplug == FT_SCSI_PLUG)
                                scsi_add_device(ft_scsi_host, channel, scsi_hotplug.event[i].scsi_id, lun);
                        else{
                                ft_sdev = scsi_device_lookup(ft_scsi_host, channel, scsi_hotplug.event[i].scsi_id, lun);
                                if(ft_sdev){
                                        scsi_remove_device(ft_sdev);
                                        scsi_device_put(ft_sdev);
                                }
                        }

                        scsi_hotplug.event[i].present = 0;
                        scsi_hotplug.event_cnt--;
                }
		spin_unlock_irqrestore(&wkq_lock, flags);
        }

        void GEN_CALLBACK scsi_autoaware(IN bpVOID ComponentExtension, IN bpVOID Timer, IN bpVOID Context){

                if( scsi_hotplug.event_cnt > 0){
                        #ifdef TASKLET_IMPLEMENT
                                tasklet_schedule( &scsi_aware_tasklet );
                        #else ifdef WORKQUEUE_IMPLEMENT
                                schedule_work( &scsi_aware_work );
                        #endif
                }

                OSD_RequestTimer( ComponentExtension, 10*SECOND_IN_TIMER, scsi_autoaware, 0, 0);
        }
#endif


#ifdef LINUX_SCSI_HOTPLUG_AWARE
  //20090220 add by Dirk
  #if KERNEL_VERSION_BEFORE(2,6,20)
	#define INITWORK INIT_WORK(&scsi_aware_work,(void *)do_ft_scsi_hotplug_aware, (void *)ft_scsi_host);
  #else
	#define INITWORK INIT_WORK(&scsi_aware_work,(void *)do_ft_scsi_hotplug_aware);
  #endif

	#define	Hook_On_SCSI_HotPlug_Aware	\
		do{	\
                	ft_scsi_host = shpnt;	\
					\
                	tasklet_init(&scsi_aware_tasklet, (void *)do_ft_scsi_hotplug_aware, (void *)ft_scsi_host);	\
                	INITWORK 		\
                	ft_scsi_timer = OSD_RequestTimer( pOSDExtension, 10*SECOND_IN_TIMER, scsi_autoaware, 0, 0);	\
		}while(0)
#endif
