#ifndef OSD_INC_h
#define OSD_INC_h

#if !defined( LINUX_VERSION_CODE) || !defined(KERNEL_VERSION)
#include <linux/version.h>
#endif

#define KERNEL_VERSION_AFTER(x,y,z)     	( LINUX_VERSION_CODE>KERNEL_VERSION(x,y,z) )
#define KERNEL_VERSION_BEFORE(x,y,z)     	( LINUX_VERSION_CODE<KERNEL_VERSION(x,y,z) )
#define KERNEL_VERSION_EQUAL(x,y,z)     	( LINUX_VERSION_CODE == KERNEL_VERSION(x,y,z) )
#define KERNEL_VERSION_AFTER_EQUAL(x,y,z)	( KERNEL_VERSION_AFTER(x,y,z) || KERNEL_VERSION_EQUAL(x,y,z))
#define KERNEL_VERSION_BEFORE_EQUAL(x,y,z)      ( KERNEL_VERSION_BEFORE(x,y,z) || KERNEL_VERSION_EQUAL(x,y,z))


/* Include OS related head files*/

#include <linux/nmi.h>
/* add for SuSe 10.1(kernel 2.6.16.13-4) gcc_v4, undefind touch_nmi_watchdog, by sandy 20070112*/


#include <linux/init.h>
#include <stdarg.h>
#include <asm/io.h>
#include <asm/string.h>
#include <asm/irq.h>
#include <asm/byteorder.h>
#include <linux/version.h>
#include <linux/string.h>
#include <linux/errno.h>
#include <linux/kernel.h>
#include <linux/ioport.h>
#include <linux/delay.h>
#include <linux/sched.h>
#include <linux/time.h>
#include <linux/pci.h>
#include <linux/proc_fs.h>

#if KERNEL_VERSION_BEFORE(2,5,0)
	#include <linux/blk.h>
#else
	#include <linux/interrupt.h>
	#include <linux/blkdev.h>
#endif

#ifdef _64BPLATFORM
#include <linux/syscalls.h>
#if KERNEL_VERSION_BEFORE(2,6,22)  /* no ioctl32.h file on kernel > 2.6.22, rock find it */
	#include <linux/ioctl32.h>
#endif
#endif
/* add for SuSe 10(kernel 2.6.13.13-4) gcc_v4, undefind sys_ioctl,register_ioctl32_conversion, by sandy 20070117*/

#if defined(_32BPLATFORM)
#if KERNEL_VERSION_BEFORE(2,5,0)
	#include <asm/kmap_types.h>
	#include <linux/highmem.h>
#else
	#include <asm/kmap_types.h>
	#include <asm/highmem.h>
#endif
#endif


//#include <linux/tqueue.h>
#include <linux/types.h>
#include <linux/hdreg.h>
#include <linux/notifier.h>        
#include <linux/reboot.h>

#include <linux/module.h>
#include <linux/spinlock.h>
#include <linux/smp.h>

#include <asm/uaccess.h>
#include <scsi.h>
#if KERNEL_VERSION_BEFORE(2,5,0)
	#include <sd.h>
	#include <hosts.h>
#else
	#include <scsi_cmnd.h>
	#include <scsi_host.h>
	#include <scsi_device.h>
	typedef struct scsi_cmnd	Scsi_Cmnd;
	#define scsi_to_pci_dma_dir(scsi_dir) ((int)(scsi_dir))
#endif

/* Include internal head files */
#include "napa_cfg.h"
#include "gen_typs.h"
#include "gen_ds.h"
#include "cam_exp.h"
//#include "eng_intr.h"
#include "eng_scsi.h"
#include "eng_req.h"
#include "eng_type.h"
#include "osd_cons.h"
#include "osd_dbg.h"
#include "osd_dimm.h"
#include "eng_code.h"
#include "eng_exp.h"
/* #include "dm_exp.h" */
//#include "pbm_exp.h"
//#include "pbm_mini.h"
#include "cc_exp.h"
#include "cc_mini.h"
#include "osd_exp.h"
#include "osd_scsi.h"
#include "osd_timer.h"
#include "osd_ioctl.h"
#ifdef OSD_BOUNCE_BUFFER
#include "osd_bb.h"
#endif
#include "osd_inter.h"
#include "osd_main.h"
#include "osd_cmpm.h"
#include "osd_wrap.h"

#include "linux_dbg.h" 

extern bpVOID OSD_GetSGAddress(bpREQ p_rq);

#if defined (ENABLE_TOLAPAI_NAS)
        #define TOUCH_NMI_WATCHDOG() watchdog_reload()
#else
	#if defined _64BPLATFORM
        	#define TOUCH_NMI_WATCHDOG() touch_nmi_watchdog()
	#elif defined _32BPLATFORM
       		#define TOUCH_NMI_WATCHDOG()
	#endif
#endif


#endif /* OSD_INC_H */
