#include "osd_wrap.h"
#include "gen_typs.h"

int wrap_print(const char *fmt,...)
{
        static char buf[100];
        va_list args;
        int i;
        va_start(args,fmt);
        i=vsprintf(buf,fmt,args);
        i=printk(buf);
        va_end(args);
        return i;
}

void* wrap_memcpy(void* dest, const void* src, unsigned n)
{
        return memcpy(dest, src, n);
}


#if defined(ATI)

#if 0
	void* wrap_memcpy(void* dest, const void* src, unsigned n)
	{
       		return memcpy(dest, src, n);
	}
#endif

U32 g_Misc_CTL = 0;     //Fast boot for HP Laptop by tammy

#endif


unsigned long *wrap_P2V(void *paddr){
        return phys_to_virt(paddr);
}

unsigned long *wrap_V2P(void *paddr){
        return virt_to_phys(paddr);
}



spinlock_t      kmap_lock = SPIN_LOCK_UNLOCKED;

/* The number of KMAP_TYPEs are limited, we should be carefully when using it.
*  Before we used KM_USER0/KM_USER1, but it seems conflicts w/ some other system code concurrently.
*  Also, some(all ?) r/w compare errors maybe caused by this issue...
*/
unsigned char *wrap_HIGHMAP_PAGE(void *paddr, int phase){
        unsigned char *page_addr;
        unsigned long flags;
        int idx, i;

        spin_lock_irqsave(&kmap_lock, flags);

        if(phase == 0){
                page_addr = kmap_atomic((struct page*)paddr, KM_SKB_SUNRPC_DATA);
        }else if(phase == 1){
                page_addr = kmap_atomic((struct page*)paddr, KM_SKB_DATA_SOFTIRQ);
        }else if(phase == 2){
#if KERNEL_VERSION_BEFORE(2,5,0)
                page_addr = kmap_atomic((struct page*)paddr, KM_NETDUMP);
#else
                page_addr = kmap_atomic((struct page*)paddr, KM_BIO_SRC_IRQ);
#endif
        }

        spin_unlock_irqrestore(&kmap_lock, flags);
        return page_addr;
}

unsigned char* wrap_HIGHMAP(unsigned char *vaddr, void *p_src){
        unsigned char *addr;
        addr = (vaddr + ((U32)p_src & ~PAGE_MASK));
        return addr;
}


void wrap_HIGHUNMAP_PAGE(void *page_addr, int phase){
        unsigned long flags;
        int idx;

        spin_lock_irqsave(&kmap_lock, flags);
        if(phase == 0){
                kunmap_atomic(page_addr, KM_SKB_SUNRPC_DATA);
        }else if(phase == 1){
                kunmap_atomic(page_addr, KM_SKB_DATA_SOFTIRQ);
        }else if(phase == 2){
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
                kunmap_atomic(page_addr, KM_NETDUMP);
#else
                kunmap_atomic(page_addr, KM_BIO_SRC_IRQ);
#endif
        }

        spin_unlock_irqrestore(&kmap_lock, flags);
}

void wrap_memcpyfromio(void* mmiobase, const void* buffer, unsigned long count)
{
        memcpy_fromio( (char *)buffer, (char *)mmiobase, count);
}

void wrap_memcpytoio(void* mmiobase, const void* buffer, unsigned long count)
{
        memcpy_toio( (char *)mmiobase, (char *)buffer, count);
}


U32 wrap_readl(void * mmiobase)
{
        return readl(mmiobase);
}

U16 wrap_readw(void * mmiobase)
{
        return readw(mmiobase);
}

U8 wrap_readb(void * mmiobase)
{
        return readb(mmiobase);
}

void wrap_writel(void* mmiobase, U32 data)
{
        writel(data, mmiobase);
}

void wrap_writew(void* mmiobase, U16 data)
{
        writew(data, mmiobase);
}

void wrap_writeb(void* mmiobase, U8 data)
{
        writeb(data, mmiobase);
}

unsigned char wrap_inb(int addr)
{
        return(inb(addr));
}
unsigned short wrap_inw(int addr)
{
        return(inw(addr));
}
unsigned int wrap_inl(int addr)
{
        return(inl(addr));
}

void wrap_outb(int addr, unsigned char b)
{
        outb(b,addr);
}

void wrap_outw(int addr, unsigned short b)
{
        outw(b,addr);
}

void wrap_outl(int addr, unsigned int b)
{
        outl(b,addr);
}

struct pci_dev *global_pcidev;
void *wrap_get_pcidev(void){
        return global_pcidev;
}
