#ifndef _OSD_WRAP_H_
#define _OSD_WRAP_H_

#include "osd_inc.h"

extern spinlock_t      kmap_lock;
extern struct pci_dev *global_pcidev;

extern int wrap_print(const char *fmt,...);
extern void* wrap_memcpy(void* dest, const void* src, unsigned n);
extern unsigned long *wrap_P2V(void *paddr);
extern unsigned long *wrap_V2P(void *paddr);
extern unsigned char *wrap_HIGHMAP_PAGE(void *paddr, int phase);
extern unsigned char* wrap_HIGHMAP(unsigned char *vaddr, void *p_src);
extern void wrap_HIGHUNMAP_PAGE(void *page_addr, int phase);   
extern void wrap_memcpyfromio(void* mmiobase, const void* buffer, unsigned long count);
extern void wrap_memcpytoio(void* mmiobase, const void* buffer, unsigned long count);
extern U32 wrap_readl(void * mmiobase);
extern U16 wrap_readw(void * mmiobase);
extern U8 wrap_readb(void * mmiobase);
extern void wrap_writel(void* mmiobase, U32 data);
extern void wrap_writew(void* mmiobase, U16 data);
extern void wrap_writeb(void* mmiobase, U8 data);
extern unsigned char wrap_inb(int addr);
extern unsigned short wrap_inw(int addr);
extern unsigned int wrap_inl(int addr);
extern void wrap_outb(int addr, unsigned char b);
extern void wrap_outw(int addr, unsigned short b);
extern void wrap_outl(int addr, unsigned int b);

extern void *wrap_get_pcidev(void);

#if KERNEL_VERSION_BEFORE(2,6,24)
        #define t3_sg_page(x)   (x)->page
#else
        #define t3_sg_page(x)   sg_page(x)
#endif

#if KERNEL_VERSION_BEFORE(2,6,25)
        #define t3_request_buffer(x) (x)->request_buffer
	#define t3_request_bufflen(x)	(x)->request_bufflen
        #define t3_use_sg(x)    (x)->use_sg
#else
        #define t3_request_buffer(x) (x)->sdb.table.sgl //scsi_sglist(x)
	#define t3_request_bufflen(x)	scsi_bufflen(x)
        #define t3_use_sg(x)    (x)->sdb.table.nents  //scsi_sg_count(x)
#endif

#endif
